#include "common.h"
#include "pocc.h"







struct PS_INPUT
{
float2 texCoord : TEXCOORD0;

float3 vLightTS : TEXCOORD1_centroid;

float3 vViewTS : TEXCOORD2_centroid;

float2 vParallaxOffsetTS : TEXCOORD3_centroid;

float3 vNormalWS : TEXCOORD4_centroid;

float3 vViewWS : TEXCOORD5_centroid;
};

float4 ComputeIllumination( float2 texCoord, float3 vLightTS,
float3 vViewTS, float fOcclusionShadow )
{
// Sample the normal from the normal map for the given texture sample:
float3 vNormalTS = normalize( tex2D( s_normal, texCoord ) * 2 - 1 );
// Sample base map:
float4 cBaseColor = tex2D( s_base, texCoord );
// Compute diffuse color component:
float4 cDiffuse = saturate( dot( vNormalTS, vLightTS )) *
cDiffuseColor;
// Compute specular component:
float3 vReflectionTS = normalize( 2 * dot( vViewTS, vNormalTS ) *
vNormalTS - vViewTS );
float fRdotL = dot( vReflectionTS, vLightTS );
float4 cSpecular = saturate( pow( fRdotL, fSpecularExponent )) *
cSpecularColor;
float4 cFinalColor = (( cAmbientColor + cDiffuse ) * cBaseColor +
cSpecular ) * fOcclusionShadow;
return cFinalColor;
}

